UNIT mTQuadrat;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses ExtCtrls, Graphics, mTPunkt, mTEckenobjekt;

type
  TQuadrat = class(TEckenobjekt)

  private //Attribute
    Eckpunkt1 : TPunkt;
    Eckpunkt2 : TPunkt;

     //Objektbeziehungen:
        // hatTPunkt1, // hatTPunkt2 : TPunkt;

  public //Methoden
    constructor create (x1: integer; y1: integer; x2: integer; y2: integer; LF: TColor; FF: TColor); virtual;
    procedure SetzeEckpunkt1 (pEckpunkt1: TPunkt); virtual;
    procedure SetzeEckpunkt2 (pEckpunkt2: TPunkt); virtual;
    procedure Zeichnen (PB: TPaintbox); override;
    function GibEckpunkt1 : TPunkt; virtual;
    function GibEckpunkt2 : TPunkt; virtual;
    destructor destroy; override;
    procedure Markiere(PB: TPaintbox); override;
    procedure move(xpx,ypx: integer); override;
    function fit(x,y: integer): integer; override;
   end;

implementation

//+---------------------------------------------------------------------
//|         TQuadrat: Methodendefinition 
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor TQuadrat.create (x1: integer; y1: integer; x2: integer; y2: integer; LF: TColor; FF: TColor);
begin
  inherited create(LF,FF);
  Eckpunkt1:= TPunkt.create(x1,y1,LF);
  Eckpunkt2:= TPunkt.create(x2,y2,LF);
  if abs(x1-x2)>abs(y1-y2)
  then begin
         if x2>x1 then Eckpunkt2.SetzeX(x1+abs(y2-y1))
                  else Eckpunkt2.SetzeX(x1-abs(y2-y1))
       end
  else if abs(x1-x2)<abs(y1-y2)
       then begin
              if y2>y1 then Eckpunkt2.SetzeY(y1+abs(x2-x1))
                       else Eckpunkt2.SetzeY(y1-abs(x2-x1))
            end;
end;

//-------- SetzeEckpunkt1 (public) -------------------------------------
procedure TQuadrat.SetzeEckpunkt1 (pEckpunkt1: TPunkt);
begin
  Eckpunkt1 := pEckpunkt1
end;

//-------- SetzeEckpunkt2 (public) -------------------------------------
procedure TQuadrat.SetzeEckpunkt2 (pEckpunkt2: TPunkt);
begin
  Eckpunkt2 := pEckpunkt2
end;

//-------- Zeichnen (public) -------------------------------------------
procedure TQuadrat.Zeichnen (PB: TPaintbox);
begin
  inherited Zeichnen(PB);
  PB.Canvas.Rectangle(Eckpunkt1.GibX,Eckpunkt1.GibY,Eckpunkt2.GibX,Eckpunkt2.Giby);
end;

//-------- GibEckpunkt1 (public) ---------------------------------------
function TQuadrat.GibEckpunkt1 : TPunkt;
begin
  result  := Eckpunkt1
end;

//-------- GibEckpunkt2 (public) ---------------------------------------
function TQuadrat.GibEckpunkt2 : TPunkt;
begin
  result  := Eckpunkt2
end;

//-------- destroy (public) --------------------------------------------
destructor TQuadrat.destroy;
begin
  Eckpunkt1.free;
  Eckpunkt2.free;
  inherited destroy;
end;

//-------- Markiere (public) -----------------------------------------
procedure TQuadrat.Markiere(pb: TPaintbox);
begin
  inherited Markiere(PB);
  pb.Canvas.Rectangle(GibEckpunkt1.GibX-4,GibEckpunkt1.GibY-4,GibEckpunkt1.GibX+4,GibEckpunkt1.GibY+4);
  pb.Canvas.Rectangle(GibEckpunkt2.GibX-4,GibEckpunkt2.GibY-4,GibEckpunkt2.GibX+4,GibEckpunkt2.GibY+4);
  pb.Canvas.Rectangle(GibEckpunkt1.GibX-4,GibEckpunkt2.GibY-4,GibEckpunkt1.GibX+4,GibEckpunkt2.GibY+4);
  pb.Canvas.Rectangle(GibEckpunkt2.GibX-4,GibEckpunkt1.GibY-4,GibEckpunkt2.GibX+4,GibEckpunkt1.GibY+4);
end;

procedure TQuadrat.move(xpx,ypx: integer);
begin
  Eckpunkt1.move(xpx,ypx);
  Eckpunkt2.move(xpx,ypx);
end;

function TQuadrat.fit(x,y: integer): integer;
begin
  fit:= round(sqrt(sqr(x-(Eckpunkt1.GibX+Eckpunkt2.gibx)div 2)+sqr(y-(eckpunkt1.GibY+eckpunkt2.GibY) div 2)));
end;

end.
