unit mtGrafikobjekte;

interface

uses U_List, mtZeichenobjekt, ExtCtrls;

type TGrafikliste = class
     private
       Objekte: TLinList;
       pPaintbox: TPaintbox;
     public
       constructor create(PB: TPaintbox);
       procedure previous;
       procedure next;
       procedure toFirst;
       procedure toLast;
       procedure insert(o: TZeichenobjekt);
       procedure delete;
       procedure refresh;
     end;

implementation

constructor TGrafikliste.create(PB: TPaintbox);
begin
 pPaintbox:= PB;
 Objekte:= TLinList.create;
end;

procedure TGrafikliste.previous;
begin
  Objekte.previous;
  if Objekte.isBefore then Objekte.next;
  refresh;
end;

procedure TGrafikliste.next;
begin
  Objekte.next;
  if Objekte.isBehind then Objekte.previous;
  refresh;
end;

procedure TGrafikliste.toFirst;
begin
  Objekte.toFirst;
  refresh;
end;

procedure TGrafikliste.toLast;
begin
  Objekte.toLast;
  refresh;
end;

procedure TGrafikliste.insert(o: TZeichenobjekt);
begin
  Objekte.toLast;
  Objekte.insertBehind(o);
  Objekte.next;
  refresh;
end;

procedure TGrafikliste.refresh;
var o: TZeichenobjekt;
begin
  o:= TZeichenobjekt(Objekte.getItem);
  pPaintbox.Refresh;
  Objekte.toFirst;
  while not Objekte.isBehind
  do begin
       TZeichenobjekt(Objekte.getItem).Zeichnen(pPaintbox);
       Objekte.next;
     end;
  if o<> nil
  then begin
          Objekte.toFirst;
          while (not Objekte.isBehind) and (Objekte.getItem<>o)
          do Objekte.next;
          o.Markiere(pPaintbox);
       end;
end;

procedure TGrafikliste.delete;
begin
  if Objekte.getItem<>nil
  then begin
         Objekte.getItem.Free;
         Objekte.delete;
         if Objekte.isBehind then Objekte.previous;
         refresh;
       end;

end;

end.
